\LSTFIX.XPL	APR-10-98	Version 0.2
\Copyright (C) 1998 Richard Ottosen
\
\This program removes unwanted junk from Microchip's MPASM .LST files.
\ The resulting output file has the extension ".FIX." Macros must be
\ expanded (i.e. don't use NOEXPAND).
\
\This program is free software; you can redistribute it and/or modify it under
\ the terms of the GNU General Public License version 2 as published by the
\ Free Software Foundation.
\This program is distributed in the hope that it will be useful, but WITHOUT
\ ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
\ FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
\ details.
\You should have received a copy of the GNU General Public License along with
\ this program (in the file LICENSE.DOC); if not, write to the Free Software
\ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
\
\You can reach me at:			Mail:	Richard Ottosen
\ Email: ottosen@idcomm.com			1461 Perry St.
\						Denver, CO 80204, USA
\
\This program was compiled with the version 2.3 XPL0 compiler (XPLX, 16-bit).
\ I can send you a copy of this compiler if you can't find it.
\

inc	\CXPL\CODESI;	\Include code definitions for intrinsic routines

\DOSOpen variables:
int	Cpureg,		\Address of CPU register array
	PSPSEG,		\Paragraph address of PSP segment (for file I/O)
	DATASEG;	\Paragraph address of data segment (heap & stack)
def	FileNameSize=40;	\Maximum number of characters in a file name
char	FixFileName(FileNameSize); \Fixed file name (.FIX)

def	Nul=$00, Bel=$07, BS=$08, Tab=$09, LF=$0A, FF=$0C,	\Control chars
	CR=$0D, Up=$18, Dn=$19, EOF=$1A, Esc=$1B, Space=$20, Ctrl=$40;

\===============================================================================

func	StrLen(Str);	\Returns the number of characters in a string
char	Str;
int	I;
for I:= 0, 32766 do
	if Str(I) >= $80 then return I+1;

\=============================== DOS FILE I/O ==================================

proc	DOSOpen;	\Routine to open MS-DOS files
int	Inx,		\Index into Tail
	InHand;		\Input file handle

char	InFileName(FileNameSize); \Input file name
char	Tail, TLen(80);



proc	CopyName(From, To, Ext);
\Copy file name from "From" to "To" and append Ext
char	From, To,	\Strings are terminated by 0 & must be <= FileNameSize
	Ext;		\Extension started with "." and terminated with an
			\ unused char with MSB set
int	I, J, Ch;
begin
I:= 0;
loop	begin
	Ch:= From(I);
	if Ch=0 ! Ch=^. then quit;
	To(I):= Ch;
	if I < FileNameSize-1 then I:= I +1;
	end;

for J:= 0, 3 do
	begin
	To(I):= Ext(J);
	if I < FileNameSize-1 then I:= I +1;
	end;
To(I):= 0;
end;	\CopyName



proc	CopyNameX(From, To, Ext);
\Copy file name from "From" to "To" and append Ext if no extension is given
char	From, To,	\Strings are terminated by 0 & must be <= FileNameSize
	Ext;		\Extension started with "." and terminated with an
			\ unused char with MSB set
int	I, J, Ch, HaveExt;
begin
I:= 0;
HaveExt:= false;
loop	begin
	Ch:= From(I);
	if Ch = 0 then quit;
	if Ch = ^. then HaveExt:= true;
	To(I):= Ch;
	if I < FileNameSize-1 then I:= I +1;
	end;
if HaveExt then return;

for J:= 0, 3 do
	begin
	To(I):= Ext(J);
	if I < FileNameSize-1 then I:= I +1;
	end;
To(I):= 0;
end;	\CopyNameX



proc	GetName(Name);
\Inputs: Inx, Tail, FileNameSize
char	Name;
int	I, Ch;
begin
while Tail(Inx) = Space do Inx:= Inx +1;
I:= 0;
repeat	Ch:= Tail(Inx);
	Inx:= Inx +1;
	if Ch=Space ! Ch=CR then Ch:= 0;	\Terminate Name with 0
	Name(I):= Ch;
	if I < FileNameSize-1 then I:= I +1;
until Ch =0;
end;	\GetName



begin	\DOSOpen
Tail:= TLen +1;
Blit(PSPSEG, $80, DATASEG, TLen, 79);
if TLen(0)>79 then TLen(0):= 79;

Inx:= 0;
GetName(InFileName);
if InFileName(0) = 0 then		\Fatal error if no file specified
	[Text(0, "No input listing (.LST) file specified
");   exit];

CopyName(InFileName, FixFileName, ".FIX ");
CopyNameX(InFileName, InFileName, ".LST ");
Trap(false);
InHand:= Fopen(InFileName, 0);		\Get input handle
if Geterr \#0\ then 
	[Text(0, "Listing (.LST) file not found
");   exit];
Trap(true);

Fset(InHand, ^I);
OpenI(3);
end;	\DOSOpen

\==============================================================================

proc	LoadListCode;	\Read listing (.LST) file, and load LineBuf
\ Inputs:  .LST file
\ Outputs: .FIX file
def	LineBufSize = 132+1;	\Max chars per line for mnemonics and comments
char	LineBuf(LineBufSize);	\Holds 1 line of assembly code
int	I, Ch, Match, OutHand;
char	Str1;


	proc	ReadLine;	\Read a line into the line buffer
	int	I;
	begin
	I:= 0;			\Read a line into buffer
	repeat	begin
		Ch:= ChIn(3);			\Get character
		if Ch =LF then Ch:= ChIn(3);	\Strip out linefeeds
		if Ch =EOF then return;
		LineBuf(I):= Ch;
		I:= I +1;		
		end;
	until Ch =CR ! I >=LineBufSize;
	if Ch #CR then			\Make sure the line is terminated
		begin
		repeat	begin		\ and skip the rest of the long line
			Ch:= ChIn(3);
			if Ch =EOF then return;
			end;
		until Ch =CR;
		end;
	LineBuf(I-1):= CR ! $80;	\Make it into a text string
	end;	\ReadLine


begin	\LoadListCode
OutHand:= Fopen(FixFileName, 1);	\Get output handle
Fset(OutHand, ^O);
OpenO(3);

loop	begin
	ReadLine;		\Read the next line
	if Ch= EOF then quit;	

	Str1:= "^LMPASM ";	\Is this an MPASM title line?
	Match:= true;	
	for I:= 0, StrLen(Str1)-2 do if Str1(I) #LineBuf(I) then Match:= false;
	if Match then		\Discard this line and the next 2 lines
		[ReadLine; Readline;
		 ReadLine; 	\Read another line
		];

	Str1:= "LOC  OBJECT CODE ";	\Is this a worthless MPASM line?
	Match:= true;	
	for I:= 0, StrLen(Str1)-2 do if Str1(I) #LineBuf(I) then Match:= false;
	if Match then		\Discard this line
		 ReadLine; 	\Read another line

	Str1:= "  VALUE ";	\Is this a worthless MPASM line?
	Match:= true;	
	for I:= 0, StrLen(Str1)-2 do if Str1(I) #LineBuf(I) then Match:= false;
	if Match then		\Discard this line and the next blank one
		[ReadLine;
		 ReadLine; 	\Read another line
		];

	Str1:= "                        M ";	\Is this a wasted Macro line?
	Match:= true;	
	for I:= 0, StrLen(Str1)-2 do if Str1(I) #LineBuf(I) then Match:= false;
	if Match then		\Ignore this line
		else	[Text(3,Linebuf);   ChOut(3,LF)];
	end;			\Loop back for next line
Close(3);
FClose(OutHand);
end;	\LoadListCode

\===============================================================================

begin	\Main
Cpureg:= Getreg;	\Set up for DOSOpen
PSPSEG:= Cpureg(11);
DATASEG:= Cpureg(12);

Text(0, "
LstFix 0.2
Copyright (C) 1998 Richard Ottosen

LstFix removes unwanted junk from Microchip's MPASM .LST files and saves the
result with the extension .FIX. Macros must be expanded (don't use NOEXPAND).

LstFix comes with ABSOLUTELY NO WARRANTY.

This is free software. You are welcome and encouraged to redistribute it
under certain conditions. For details see LICENSE.DOC.


Loading .LST file...
");
DOSOpen;

LoadListCode;
end;	\Main
